//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  PaleVioletRed

//
//
//
//
//

extern string TimeFrame          = "Current time frame";
extern int    AibPeriod          = 15;
extern double AibPower           = 0.75;
extern bool   Interpolate        = true;

extern string _                  = "alerts settings";
extern bool   alertsOn           = true;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = false;
extern bool   alertsEmail        = false;

extern string  __                = "arrows settings";
extern bool   ShowArrows         = true;
extern string arrowsIdentifier   = "AIB arrows1";
extern double arrowsDisplacement = 1.0;
extern color  arrowsUpColor      = DeepSkyBlue;
extern color  arrowsDnColor      = PaleVioletRed;
extern int    arrowsUpCode       = 241;
extern int    arrowsDnCode       = 242;

double aibh[];
double aibl[];
double sigb[];
double sigs[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,aibh);
   SetIndexBuffer(1,aibl);
   SetIndexBuffer(2,sigb); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,sigs); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,trend);
   
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      
   IndicatorShortName(timeFrameToString(timeFrame)+"   Adaptive Intraday Breakout");
   return(0);
}

int deinit(){  if (!calculateValue && ShowArrows) deleteArrows();  return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][2];
#define _nhr 0
#define _nlr 1

int start()
{
   int i,r,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { aibh[0] = limit+1; return(0); }
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
    
      for(i = limit, r= Bars-i-1; i >= 0; i--, r++)
      {
         double atr  = iATR(NULL,0,AibPeriod,i);
         double hrt  = MathAbs(High[i]-Low[i+AibPeriod]);
         double lrt  = MathAbs(Low[i]-High[i+AibPeriod]);
         
            //
            //
            //
            //
            //
            
            work[r][_nhr] = 0;
            work[r][_nlr] = 0;
            if (atr!=0)
            {
               work[r][_nhr] = (hrt/MathPow(AibPeriod,AibPower))/atr;
               work[r][_nlr] = (lrt/MathPow(AibPeriod,AibPower))/atr;
            }               
            double nhrMax = work[r][_nhr];
            double nlrMax = work[r][_nlr];
               for (int k=1; k<AibPeriod; k++)
               {
                  nhrMax = MathMax(nhrMax,work[r-k][_nhr]);
                  nlrMax = MathMax(nlrMax,work[r-k][_nlr]);
               }
            aibh[i] = nhrMax;
            aibl[i] = nlrMax;
            
            //
            //
            //
            //
            //

            sigb[i]  = EMPTY_VALUE;
            sigs[i]  = EMPTY_VALUE;
            trend[i] = trend[i+1];
            if (aibh[i] > aibl[i]) trend[i] =  1; 
            if (aibh[i] < aibl[i]) trend[i] = -1;
            if (trend[i] ==  1) sigb[i] = aibl[i]; 
            if (trend[i] == -1) sigs[i] = aibh[i]; 
            if (!calculateValue) manageArrow(i);
      }
      
      manageAlerts();
      return(0);
      }
      
      //
      //
      //
      //
      //
  
      limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=limit;i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
              aibh[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",AibPeriod,AibPower,0,y);
              aibl[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",AibPeriod,AibPower,1,y);
              trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",AibPeriod,AibPower,4,y);
              sigb[i]  = EMPTY_VALUE;
              sigs[i]  = EMPTY_VALUE;
              if (aibh[i] > aibl[i]) trend[i] =  1; 
              if (aibh[i] < aibl[i]) trend[i] = -1;
              if (trend[i] ==  1) sigb[i] = aibl[i]; 
              if (trend[i] == -1) sigs[i] = aibh[i];
              manageArrow(i);
            
              //
              //
              //
              //
              //
            
              if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

              //
              //
              //
              //
              //

              datetime time = iTime(NULL,timeFrame,y);
              for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
              for(int j = 1; j < n; j++)
              {
  	              aibh[i+j] = aibh[i] + (aibh[i+n] - aibh[i]) * j/n;
  	              aibl[i+j] = aibl[i] + (aibl[i+n] - aibl[i]) * j/n;
  	    
             }  	            
     }
      
     manageAlerts();   
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"buy");
         if (trend[whichBar] == -1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Adaptive intraday breakout ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Adaptive intraday breakout "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);    
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
  
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsDisplacement * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//
//
//
//
//

